Subject: Re: [PATCH 0/4] meson: parse TAP output generated by our tests

From: Junio C Hamano <[email-masked]>
Date: Tue, 27 May 2025 06:36:04 -0700

Patrick Steinhardt <[email-masked]> writes:

>> Yes, it is a very good question.  I do not mind if the answer is "it
>> should, and the make and prove shouldn't let unexpected pass go
>> unnoticed".  The difference between the build systems bothers me
>
> Indeed, a good question. The TAP specification [1] has this to say:
>
>     Should a todo test point begin succeeding, the harness may report it
>     in some way that indicates that whatever was supposed to be done has
>     been, and it should be promoted to a normal Test Point.
>
>     Harnesses must not treat failing TODO test points as a test failure.
>
>     Harneses should report TODO test points found as a list of items
>     needing work, if that is appropriate for their use case.
>
> So if my reading of this is correct then Meson isn't wrong in reporting
> this as an error -- "in some way" basically gives it full permission to
> do so. So this is plain old undefined behaviour we rely on :/

So, what should happen to succeeding TODO is left unspecified.